--- ../nagios-3.0.4/xdata/xrddefault.c	2008-06-23 22:47:50.000000000 +0200
+++ xrddefault.c	2008-11-25 12:30:44.000000000 +0100
@@ -255,7 +255,6 @@ int xrddefault_save_state_information(vo
 	unsigned long process_host_attribute_mask=0L;
 	unsigned long process_service_attribute_mask=0L;
 
-
 	log_debug_info(DEBUGL_FUNCTIONS,0,"xrddefault_save_state_information()\n");
 
 	/* make sure we have everything */
@@ -272,6 +271,7 @@ int xrddefault_save_state_information(vo
 	asprintf(&temp_file,"%sXXXXXX",xrddefault_temp_file);
 	if(temp_file==NULL)
 		return ERROR;
+	
 	if((fd=mkstemp(temp_file))==-1)
 		return ERROR;
 
@@ -558,21 +558,30 @@ int xrddefault_save_state_information(vo
 		fprintf(fp,"}\n");
 	        }
 
-	fclose(fp);
+	/* If there is a problem when saving/closing the tempfile
+	   don't write to the retentionfile and write an error to the
+	   log 
+	*/
+	if(fclose(fp)) {
+		logit(NSLOG_RUNTIME_ERROR,TRUE,"Error when closing retention tempfile: %s", strerror(errno)); 
 
-	/* move the temp file to the retention file (overwrite the old retention file) */
-	if(my_rename(temp_file,xrddefault_retention_file))
+		/* Remove the tempfile - I'm not sure this actually is a good idea */
+		unlink(temp_file); 
 		result=ERROR;
+	} else {
+		/* move the temp file to the retention file (overwrite the old retention file) */
+		if(my_rename(temp_file,xrddefault_retention_file)) {
+			logit(NSLOG_RUNTIME_ERROR,TRUE,"Error when saving retention file: %s", strerror(errno)); 
+			result=ERROR;
+		}
+	}
 
 	/* free memory */
 	my_free(temp_file);
-
 	return result;
         }
 
 
-
-
 /******************************************************************/
 /***************** DEFAULT STATE INPUT FUNCTION *******************/
 /******************************************************************/
